package org.zheng.demo;

import java.io.UnsupportedEncodingException;
import java.nio.charset.Charset;

public class ConvertViaBytes {

	private static final String ISO_8859_1 = "ISO-8859-1";
	private static final String UTF_8 = "UTF-8";

	public static void main(String[] args) {
		System.out.println("Java default Charset: " + Charset.defaultCharset());

		Charset.availableCharsets().entrySet().stream()
				.filter(c -> c.getKey().startsWith(UTF_8) || c.getKey().startsWith(ISO_8859_1))
				.forEach(c -> System.out.println("Found Charset: " + c.getKey()));

		try {
			String utf8String = "UTF-8 Text: MaryZhengäöüß测试";

			// Convert UTF-8 string to byte array using UTF-8 encoding
			byte[] utf8Bytes = utf8String.getBytes(UTF_8);

			// Convert byte array to string using ISO-8859-1 encoding
			String iso88591String = new String(utf8Bytes, ISO_8859_1);

			System.out.println("Original UTF-8 string: " + utf8String);
			System.out.println("Converted ISO-8859-1 string: " + iso88591String);
		} catch (UnsupportedEncodingException e) {
			System.out.println("Unsupported encoding: " + e.getMessage());
		}
	}

}
