package org.zheng.demo;

import java.nio.charset.Charset;

public class ConvertViaCharArray {

	private static final int LAST_CHAR = 0xFF;
	private static final String ISO_8859_1 = "ISO-8859-1";

	public static void main(String[] args) {

		String utf8String = "UTF-8 Text: MaryZhengäöüß测试";

		// Decode UTF-8 string to characters
		char[] utf8Chars = utf8String.toCharArray();

		// Encode characters to ISO-8859-1 bytes
		byte[] iso88591Bytes = new byte[utf8Chars.length];
		for (int i = 0; i < utf8Chars.length; i++) {
			char c = utf8Chars[i];
			
			if (c <= LAST_CHAR) {
				iso88591Bytes[i] = (byte) c;
			} else {
				iso88591Bytes[i] = '?'; // Replace characters not representable in ISO-8859-1
			}
		}

		// Create ISO-8859-1 string from bytes
		String iso88591String = new String(iso88591Bytes, Charset.forName(ISO_8859_1));

		System.out.println("Original UTF-8 string: " + utf8String);
		System.out.println("Converted ISO-8859-1 string: " + iso88591String);
	}

}
